package com.example.andersb.socketusingtask;

import android.app.Activity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.Socket;


public class SocketActivity extends Activity {

    private static final String SPECIAL_IP_TO_HOST_COMPUTER = "10.0.3.2";
    // GenyMotion  10.0.3.2
    // Ordinary emulator 10.0.2.2
    private static final int PORT_NUMBER = 7;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_socket);
    }

    public void buttonClicked(View view) {
        EditText editText = (EditText) findViewById(R.id.editText);
        String request = editText.getText().toString();
        Log.d("MINE", "request: " + request);

        RequestResponseTask task = new RequestResponseTask();
        task.execute(request);
        // doInBackground
        //String response = getResponse(request);

        // onPostExecute
        //TextView textView = (TextView) findViewById(R.id.textView);
        //textView.setText(response);
    }

    private class RequestResponseTask extends AsyncTask<String, Void, String> {

        @Override
        protected String doInBackground(String... request) {
            Log.d("TASK", "request: " + request[0]);
            return getResponse(request[0]);
        }

        @Override
        protected void onPostExecute(String response) {
            Log.d("TASK", "response: " + response);
            TextView textView = (TextView) findViewById(R.id.textView);
            textView.setText(response);
        }
    }

    /**
     * Will throw NetworkOnMainThreadException if executed from the main thread.
     * in API version 11 and up (aka. Honeycomb aka. Android 3.0)
     *
     * @param request
     * @return
     */
    private String getResponse(String request) {
        try {
            Socket socket = new Socket(SPECIAL_IP_TO_HOST_COMPUTER, PORT_NUMBER);
            OutputStream output = socket.getOutputStream();
            output.write((request + "\n").getBytes());
            output.flush();
            BufferedReader input = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            String response = input.readLine();
            socket.close();
            return response;
        } catch (IOException ex) {
            Log.e("SHIT", ex.toString());
            return ex.toString();
        } catch (Exception ex) {
            Log.e("SHIT", ex.toString());
            return ex.toString();
        }
    }
}
